BRICKD(8)

NAME
brickd - Tinkerforge Brick Daemon

SYNOPSIS
brickd [--help|--version|--check-config|--daemon [<log-file>]] [--debug [<filter>]] [--config-file <config-file>] [--pid-file <pid-file>]

DESCRIPTION
The brickd program is part of the Tinkerforge software infrastructure. It routes Tinkerforge Protocol (TFP) messages between Tinkerforge USB devices (Bricks) and sockets; plain TCP/IP sockets and WebSockets are supported. This allows user programs to use such sockets to communicate with Bricks and their Bricklets connected to USB without having to deal with USB themselves. The TCP/IP and WebSocket communication itself is encapsulated in API bindings available for various programming languages.

Bricks connected to USB are identified using their vendor ID (16D0) and product IDs (063D and 09E5).

By default, brickd binds to 0.0.0.0 (IPv4) and listens on port 4223 for incoming TCP/IP connections. Listening for incoming WebSocket connections is disabled by default for security reasons. The bind address (IPv4 or IPv6), listen ports, dual-stack operation and WebSocket support can be configured in the configuration file. See brickd.conf(5) for further details.

OPTIONS

--help
    Print help for command line options and exit.

--version
    Print version number and exit.

--check-config
    Check configuration file for errors, print the result and exit.

--daemon [<log-file>]
    Run as daemon and write log file to overridable location.

--debug [<filter>]
    Set log severity level to debug, overriding the configuration file value. See brickd.conf(5) for further details. Also takes an optional comma separated list of filter statements that allow to control the visibility of debug messages (FIXME: Add more details about filter statements).

--config-file <config-file>
    Read config from <config-file> instead of default location.

--pid-file <pid-file>
    Write PID to <pid-file> instead of default location.

SIGNALS
On reception of SIGHUP brickd will close and reopen its log file. On reception of SIGUSR1 brickd will scan for added or removed USB devices. This is only useful if brickd has no other means to detect USB hotplug on its own. That is the case if brickd is using a libusb-1.0 version without hotplug support (libusb-1.0 before 1.0.16).

FILES

  When run as root

/etc/brickd.conf
    The system wide default configuration file. See brickd.conf(5) for further details. Can be overridden using the --config-file option.

/var/log/brickd.log
    The system wide default daemon-mode log file. Can be overridden using the optional <log-file> argument to the --daemon option.

/run/brickd.pid
    The system wide default PID file. Can be overridden using the --pid-file option.

  When run as non-root

~/.brickd/brickd.conf
    Per user default configuration file. See brickd.conf(5) for further details. Can be overridden using the --config-file option.

~/.brickd/brickd.log
    Per user default daemon-mode log file. Can be overridden using the optional <log-file> argument to the --daemon option.

~/.brickd/brickd.pid
    Per user default PID file. Can be overridden using the --pid-file option.

BUGS
Please report all bugs you discover to https://github.com/Tinkerforge/brickd/issues

AUTHOR
Matthias Bolte <matthias@tinkerforge.com>

COPYRIGHT
Copyright (C) 2012-2018 Matthias Bolte

LICENSE
brickd is distributed under the terms of the GNU GPL v2+. This is free software; see the source for copying conditions. There is NO warranty; not even for MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

SEE ALSO
brickd.conf(5) For further information see https://www.tinkerforge.com